//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

#property copyright ""
#property link      "" 
#property indicator_chart_window

extern int object_layer = 6;
extern bool green_rat = false;
extern bool extreme_rat = true;
extern bool zone_rat = true;
extern bool all_rat = false;
extern int entry_style = 0;
extern int price_size = 3;
extern int hud_corner = 1;
extern int pos_x = 100;
extern int pos_y = 100;
extern bool show_extreme = true;
extern bool popup_hud = false;
extern bool draw_box = true;
extern bool box_highlight = true;
extern bool alert_on = true;
extern string alert_sound = "alert.wav";
extern color color_box = Silver;
extern color color_box_border = SlateBlue;
extern color color_box_shadow = Black;
extern color color_box_red = C'222,192,192';
extern color color_box_green = C'192,222,192';
extern color color_red_rat = Red;
extern color color_green_rat = Green;
extern color color_shadow = Black;

string font_rat = "chinese zodiac";
int font_hud_rat_size = 48;
int font_hud_entry_size = 42;
string font_hud = "David";
int font_rat_size = 20;

color c_box;

datetime hightime,lowtime,barstart,daystart,signaltime;
string pair,TAG;
double point;
double low,high,o,c;
double green_entry_price,red_entry_price;
datetime green_entry_time,red_entry_time;
bool green_entry,red_entry,drawhud;
int hud_r_x,hud_r_y,hud_rs_x,hud_rs_y;
int hud_box_x,hud_box_y,hud_bxb_x,hud_bxb_y,hud_bs_x,hud_bs_y;
int hud_p_x,hud_p_y,hud_ps_x,hud_ps_y;


int init(){
   point = Point;
   if(Digits == 3 || Digits == 5) point*=10;
   c_box = color_box;
   barstart = 0;
   daystart = 0;
   ObDeleteObjectsByPrefix(TAG);
   TAG = CharToStr(0x61+object_layer)+"II_IR";
   pair = Symbol();
   setHUD();
   Comment("");
   return(0);
}

int deinit(){
   ObDeleteObjectsByPrefix(TAG);
   return(0);
}

int start(){
   if(daystart != iTime(pair,PERIOD_D1,0)) {
      setVal();
      daystart = iTime(pair,PERIOD_D1,0);
   }
   if(barstart == Time[0] ) return(0);
   ObDeleteObjectsByPrefix(TAG);
   barstart = Time[0];

   setVal();
   entry();
   draw();
   return(0);
}

void entry(){
   drawhud = true;
   if(green_rat){
      green_entry = false;
      int bs = iBarShift(pair,0,signaltime);
      c_box = color_box;
      for(int i=bs;i>0;i--){
         o = Open[i];
         c = Close[i];    
         if(c>o && !green_entry) {
            green_entry_price = High[i];
            green_entry_time = Time[i];
            green_entry = true;
            if(alert_on && i==1) PlaySound(alert_sound);
            if(box_highlight)c_box = color_box_green;
            continue;
         }
         if(green_entry && Open[i] > green_entry_price){
            c_box = color_box;
            if(popup_hud)drawhud = false;
            break;
         }
      }
   }else{
      red_entry = false;
      bs = iBarShift(pair,0,signaltime);
      c_box=color_box;
      for(i=bs;i>0;i--){
         o = Open[i];
         c = Close[i];    
         if(c<o && !red_entry) {
            red_entry_price = Low[i];
            red_entry_time = Time[i];
            red_entry = true;
            if(alert_on && i==1) PlaySound(alert_sound);
            if(box_highlight) c_box = color_box_red;
            continue;
         }
         if(red_entry && Open[i] < red_entry_price){
            c_box = color_box;
            if(popup_hud)drawhud = false;
            break;
         }
      }
   }
}

void setVal(){
   int i,j;
   int limit = iBarShift(pair,0,iTime(pair,PERIOD_D1,0));
   if(green_rat){  
      low = iLow(pair,PERIOD_D1,0);
      lowtime = Time[iLowest(pair,0,MODE_LOW,limit,0)];
      if(extreme_rat && !zone_rat && !all_rat){
         signaltime = lowtime;
         return;
      }
      if(zone_rat && !all_rat){
         for(i=1;i<=limit;i++){
            if(Low[i] < low + 20*point){
               for(j=i+1;j<1000;j++) if(Close[j]>Open[j]) i++;
                                       else break;
               signaltime = Time[i];
               if(signaltime == Time[0]) continue;
               return;
            }
         }
      }
      if(all_rat){
         for(i=0;i<=limit;i++){
            if(Open[i+2]>Close[i+2] && Open[i+1]<Close[i+1]){
               signaltime = Time[i+2];
               return;
            }
         }      
      }
   }else{
      high = iHigh(pair,PERIOD_D1,0);
      hightime = Time[iHighest(pair,0,MODE_HIGH,limit,0)];
      if(extreme_rat && !zone_rat && !all_rat){
         signaltime = hightime;
         return;
      }
      if(zone_rat && !all_rat){
         for(i=1;i<=limit;i++){
            if(High[i] > high - 20*point){
               for(j=i+1;i<1000;j++) if(Close[j]<Open[j]) i++;
                                       else break;
               if(signaltime == Time[0]) continue;                                       
               signaltime = Time[i];
               return;
            }
         }
      }
      if(all_rat){
         for(i=0;i<=limit;i++){
            if(Open[i+2]<Close[i+2] && Open[i+1]>Close[i+1]){
               signaltime = Time[i+2];
               return;
            }
         }      
      }
   }
   Comment("PICK A RAT STYLE:\nEXTREME RAT ENTRY\nZONE RAT ENTRY or\nALL RAT ENTRIES");
}

void draw(){
   ObDeleteObjectsByPrefix(TAG);
   if(show_extreme){
      if(green_rat) DrawRatSymbol("a",low,lowtime,color_green_rat,font_rat,font_rat_size);
         else DrawRatSymbol("A",high,hightime,color_red_rat,font_rat,font_rat_size,180);
   }


   if(popup_hud && !drawhud) return;


   if(green_entry) DrawEntry(SYMBOL_RIGHTPRICE,green_entry_price,green_entry_time,color_green_rat,entry_style,price_size);
      else if(red_entry) DrawEntry(SYMBOL_RIGHTPRICE,red_entry_price,red_entry_time,color_red_rat,entry_style,price_size);

   if(draw_box){
      if(ObjectFind(TAG+".gauge.A1") != 0) DrawCell(0, TAG+".gauge.A1", hud_bs_x, hud_bs_y, 250, 64, color_box_shadow,hud_corner);
      if(ObjectFind(TAG+".gauge.border1") != 0) DrawCell(0, TAG+".gauge.border1", hud_bxb_x, hud_bxb_y, 250, 64, color_box_border,hud_corner);
      if(ObjectFind(TAG+".gauge.box1") != 0) DrawCell(0, TAG+".gauge.box1",    hud_box_x, hud_box_y, 248, 62, c_box,hud_corner);
   }

   if(green_rat) {
      color c = color_green_rat;
      double e = green_entry_price;
   }else{
      c = color_red_rat;
      e = red_entry_price;
      }
   if(e<point) string v = "WAIT ";
      else v = DoubleToStr(e,Digits);
   if(green_rat && !green_entry) v = "WAIT ";
      else if(!green_rat && !red_entry) v = "WAIT ";

   DrawText("a",hud_r_x,hud_r_y,c,font_rat,font_hud_rat_size,hud_corner,0,0,"9");
   DrawText("a",hud_rs_x,hud_rs_y,color_shadow,font_rat,font_hud_rat_size,hud_corner,0,0,"1");
   DrawText(v,hud_p_x,hud_p_y,c,font_hud,font_hud_entry_size,hud_corner,0,0,"9");
   DrawText(v,hud_ps_x,hud_ps_y,color_shadow,font_hud,font_hud_entry_size,hud_corner,0,0,"1");  
}

void DrawText(string t, int x, int y, color c, string f, int s, int k=0, int a=0, bool b=false, string z="")
{
   string tag = TAG+"ZZ"+z+x+y;
   ObjectDelete(tag);
   ObjectCreate(tag,OBJ_LABEL,0,0,0);
   ObjectSetText(tag,t,s,f,c);
   ObjectSet(tag,OBJPROP_XDISTANCE,x);
   ObjectSet(tag,OBJPROP_YDISTANCE,y);
   ObjectSet(tag,OBJPROP_CORNER,k);
   ObjectSet(tag,OBJPROP_ANGLE,a);
   if(b) ObjectSet(tag,OBJPROP_BACK,true);
}

void DrawRatSymbol(string t, double x, datetime y, color c, string f, int s, int a=0, bool b=false, string z="")
{
   string tag = TAG+"ZR"+z+x+y;
   ObjectDelete(tag);
   ObjectCreate(tag,OBJ_TEXT,0,0,0);
   ObjectSetText(tag,t,s,f,c);
   ObjectSet(tag,OBJPROP_PRICE1,x);
   ObjectSet(tag,OBJPROP_TIME1,y);
   ObjectSet(tag,OBJPROP_ANGLE,a);
   if(b) ObjectSet(tag,OBJPROP_BACK,true);
}

void DrawEntry(string t, double x, datetime y, color c, int s, int w, bool b=false, string z="")
{
   string tag = TAG+"ZA"+z+x+y;
   ObjectDelete(tag);
   ObjectCreate(tag,OBJ_ARROW,0,0,0);
   ObjectSet(tag,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
   ObjectSet(tag,OBJPROP_PRICE1,x);
   ObjectSet(tag,OBJPROP_TIME1,Time[0]);
   ObjectSet(tag,OBJPROP_COLOR,c);
   ObjectSet(tag,OBJPROP_WIDTH,w);
   if(b) ObjectSet(tag,OBJPROP_BACK,true);
   tag = TAG+"ZL"+z+x+y;
   ObjectDelete(tag);   
   ObjectCreate(tag,OBJ_TREND,0,0,0);
   ObjectSet(tag,OBJPROP_PRICE1,x);
   ObjectSet(tag,OBJPROP_TIME1,y);
   ObjectSet(tag,OBJPROP_PRICE2,x);
   ObjectSet(tag,OBJPROP_TIME2,Time[0]);
   ObjectSet(tag,OBJPROP_COLOR,c);
   ObjectSet(tag,OBJPROP_WIDTH,0);
   ObjectSet(tag,OBJPROP_STYLE,s);
   ObjectSet(tag,OBJPROP_RAY,false);
   if(b) ObjectSet(tag,OBJPROP_BACK,true);
   
}

void ObDeleteObjectsByPrefix(string Prefix) // code by TRO
{
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal()) {
      string ObjName = ObjectName(i);
      if(StringSubstr(ObjName, 0, L) != Prefix) {
         i++;
         continue;
      }
      ObjectDelete(ObjName);
   }
}

void DrawCell(int nWindow, string nCellName, double nX, double nY, double nWidth, double nHeight, color nColor, int cnr){ //Code from MT4 codebase
   double iHeight, iWidth, iXSpace;
   int iSquares, i;
   if(nWidth > nHeight){
     iSquares = MathCeil(nWidth/nHeight);      // Number of squares used_
     iHeight = MathRound((nHeight*100)/77);   // Real height size_
     iWidth = MathRound((nWidth*100)/77);    // Real width size_
     iXSpace = iWidth/iSquares - ((iHeight/(9-(nHeight/100)))*2);
      for(i=0;i<iSquares;i++){
         ObjectCreate(nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText(nCellName+i, CharToStr(110),iHeight, "Wingdings", nColor);
         ObjectSet(nCellName+i, OBJPROP_XDISTANCE,nX + iXSpace*i);
         ObjectSet(nCellName+i, OBJPROP_YDISTANCE,nY);    
         ObjectSet(nCellName+i, OBJPROP_BACK, false);
         ObjectSet(nCellName+i, OBJPROP_CORNER, cnr);
      }        
   }else{
      iSquares = MathCeil(nHeight/nWidth);      // Number of squares used_
      iHeight  = MathRound((nHeight*100)/77);   // Real height size_
      iWidth   = MathRound((nWidth*100)/77);    // Real width size_
      iXSpace  = iHeight/iSquares - ((iWidth/(9-(nWidth/100)))*2);
      for(i=0;i<iSquares;i++){
         ObjectCreate   (nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText  (nCellName+i, CharToStr(110),iWidth, "Wingdings", nColor);
         ObjectSet      (nCellName+i, OBJPROP_XDISTANCE,nX);
         ObjectSet      (nCellName+i, OBJPROP_YDISTANCE,nY + iXSpace*i);    
         ObjectSet      (nCellName+i, OBJPROP_BACK, false);
         ObjectSet      (nCellName+i, OBJPROP_CORNER, cnr);
      }
   }
}

void setHUD(){
   if(hud_corner > 3) hud_corner=0;
   switch(hud_corner){
      case 0 : hud_box_x = pos_x-97;
               hud_box_y = pos_y+6;
               hud_bs_x = pos_x-97;
               hud_bs_y = pos_y+6;
               hud_bxb_x = pos_x-98;
               hud_bxb_y = pos_y+5;
               hud_r_x = pos_x-85;
               hud_r_y = pos_y+31;
               hud_rs_x = pos_x-84;
               hud_rs_y = pos_y+32;
               hud_p_x = pos_x-15;
               hud_p_y = pos_y+38;
               hud_ps_x = pos_x-14;
               hud_ps_y = pos_y+39;
               break;
      case 1 : hud_box_x = pos_x-97;
               hud_box_y = pos_y+6;
               hud_bs_x = pos_x-99;
               hud_bs_y = pos_y+6;
               hud_bxb_x = pos_x-98;
               hud_bxb_y = pos_y+5;
               hud_r_x = pos_x+90;
               hud_r_y = pos_y+31;
               hud_rs_x = pos_x+89;
               hud_rs_y = pos_y+32;
               hud_p_x = pos_x-86;
               hud_p_y = pos_y+38;
               hud_ps_x = pos_x-87;
               hud_ps_y = pos_y+39;
               break;
      case 2 : hud_box_x = pos_x-97;
               hud_box_y = pos_y+6;
               hud_bs_x = pos_x-97;
               hud_bs_y = pos_y+4;
               hud_bxb_x = pos_x-98;
               hud_bxb_y = pos_y+5;
               hud_r_x = pos_x-85;
               hud_r_y = pos_y+39;
               hud_rs_x = pos_x-84;
               hud_rs_y = pos_y+38;
               hud_p_x = pos_x-15;
               hud_p_y = pos_y+38;
               hud_ps_x = pos_x-14;
               hud_ps_y = pos_y+39;
               break;
      case 3 : hud_box_x = pos_x-96;
               hud_box_y = pos_y+6;
               hud_bs_x = pos_x-98;
               hud_bs_y = pos_y+4;
               hud_bxb_x = pos_x-97;
               hud_bxb_y = pos_y+5;
               hud_r_x = pos_x+90;
               hud_r_y = pos_y+39;
               hud_rs_x = pos_x+89;
               hud_rs_y = pos_y+38;
               hud_p_x = pos_x-86;
               hud_p_y = pos_y+38;
               hud_ps_x = pos_x-87;
               hud_ps_y = pos_y+39;
               break;
   }

}
